package com.lemoulinstudio.jnag.jse;

import com.lemoulinstudio.jnag.common.Remote;

/**
 * Interface for local objects who represent a view of a remote one,
 * which is typically a proxy.
 *
 * @author Vincent Cantin
 */
public interface View<T extends Remote> {

  /**
   * Returns the viewed object.
   *
   * @return The viewed object.
   */
  public T getViewedObject();
}
